typedef struct STACK* link;

struct STACK {
	char item; 
	link next; 
};

static link head;

link create(char item, link next)      
{ 
	link x = malloc(sizeof(*x));
	x->item = item; 
	x->next = next;     
	return x;                         
}                                   

void stack_create(void) 
{ 
	head = NULL; 
}

int stack_free()
{ 
	return head == NULL; 
}

void push(char item)
{ 
	head = create(item, head); 
}

char pop()
{ 
	char item = head->item;
	link t = head->next; 
	free(head); 
	head = t;
	return item;
}

